package com.nisum.employeeservice.service;

import com.nisum.employeeservice.exception.ResourceNotFoundException;
import com.nisum.employeeservice.model.Employee;
import com.nisum.employeeservice.repository.EmployeeRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Service;

import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Optional;

@Service
public class EmployeeService {

  @Autowired EmployeeRepository employeeRepository;


  public List<Employee> findAllEmployees() {
    /*some business*/
    return employeeRepository.findAll();
  }


  public Employee addEmployee(Employee employee) {
    return employeeRepository.save(employee);
  }

//  public Employee deleteEmployee(Employee employee) {
//    Employee employeeToDelete = employeeRepository.getOne(employee.getId());
//  }

  public Optional<Employee> getEmployeeById(Long employeeId) {
    return employeeRepository.findById(employeeId);
  }

  public Map<String, Boolean> deleteEmployee(Long employeeId) throws ResourceNotFoundException {
    Employee employeeToDelete =
            employeeRepository.findById(employeeId).orElseThrow(() -> new ResourceNotFoundException("Employee with " +
                    " id: "  + employeeId + " not found"));
    employeeRepository.delete(employeeToDelete);
    Map<String, Boolean> deleteResponse = new HashMap<>();
    deleteResponse.put("Deleted", Boolean.TRUE);
    return deleteResponse;
  }

  public Employee updateEmployee(Long employeeId, Employee updatedEmployeeData) throws ResourceNotFoundException {
    Employee employeeToUpdate =
            employeeRepository.findById(employeeId).orElseThrow(() -> new ResourceNotFoundException("Employee with " +
                    "id: " + employeeId + " not found"));
    employeeToUpdate.setFirstName(updatedEmployeeData.getFirstName());
    employeeToUpdate.setLastName(updatedEmployeeData.getLastName());
    Employee updatedEmployee = employeeRepository.save(employeeToUpdate);
    return updatedEmployee;
  }
}
